From bf7ae81229e7e7e361575c4f0af4a7b43644d649 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 17 2020 07:36:05 +0000
Subject: [PATCH 1432/2232] Remove Pin UniquePtr support


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 908d8bd..4f703b1 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -9,7 +9,6 @@ use crate::syntax::{
 };
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned, ToTokens};
-use std::collections::BTreeSet as Set;
 use std::mem;
 use syn::{parse_quote, Result, Token};
 
@@ -61,7 +60,6 @@ fn expand(ffi: Module, apis: &[Api], types: &Types) -> TokenStream {
         }
     }
 
-    let mut expanded_unique_ptr = Set::new();
     for ty in types {
         let explicit_impl = types.explicit_impls.get(ty);
         if let Type::RustBox(ty) = ty {
@@ -80,7 +78,6 @@ fn expand(ffi: Module, apis: &[Api], types: &Types) -> TokenStream {
             if let Type::Ident(ident) = &ptr.inner {
                 if Atom::from(&ident.rust).is_none()
                     && (explicit_impl.is_some() || !types.aliases.contains_key(&ident.rust))
-                    && expanded_unique_ptr.insert(&ident.rust)
                 {
                     expanded.extend(expand_unique_ptr(ident, types, explicit_impl));
                 }
@@ -310,10 +307,7 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                 quote!(#var.as_mut_ptr() as *const ::cxx::private::RustString)
             }
             Type::RustBox(_) => quote!(::std::boxed::Box::into_raw(#var)),
-            Type::UniquePtr(ptr) => match ptr.pinned {
-                false => quote!(::cxx::UniquePtr::into_raw(#var)),
-                true => quote!(::cxx::UniquePtr::__pin_into_raw(#var)),
-            },
+            Type::UniquePtr(_) => quote!(::cxx::UniquePtr::into_raw(#var)),
             Type::RustVec(_) => quote!(#var.as_mut_ptr() as *const ::cxx::private::RustVec<_>),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident.rust == RustString => match ty.mutable {
@@ -407,10 +401,7 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                         quote!(#call.into_vec())
                     }
                 }
-                Type::UniquePtr(ptr) => match ptr.pinned {
-                    false => quote!(::cxx::UniquePtr::from_raw(#call)),
-                    true => quote!(::cxx::UniquePtr::__pin_from_raw(#call)),
-                },
+                Type::UniquePtr(_) => quote!(::cxx::UniquePtr::from_raw(#call)),
                 Type::Ref(ty) => match &ty.inner {
                     Type::Ident(ident) if ident.rust == RustString => match ty.mutable {
                         false => quote!(#call.as_string()),
@@ -589,10 +580,7 @@ fn expand_rust_function_shim_impl(
                     quote!(::std::mem::take((*#ident).as_mut_vec()))
                 }
             }
-            Type::UniquePtr(ptr) => match ptr.pinned {
-                false => quote!(::cxx::UniquePtr::from_raw(#ident)),
-                true => quote!(::cxx::UniquePtr::__pin_from_raw(#ident)),
-            },
+            Type::UniquePtr(_) => quote!(::cxx::UniquePtr::from_raw(#ident)),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(i) if i.rust == RustString => match ty.mutable {
                     false => quote!(#ident.as_string()),
@@ -636,10 +624,7 @@ fn expand_rust_function_shim_impl(
                 Some(quote!(::cxx::private::RustVec::from))
             }
         }
-        Type::UniquePtr(ptr) => match ptr.pinned {
-            false => Some(quote!(::cxx::UniquePtr::into_raw)),
-            true => Some(quote!(::cxx::UniquePtr::__pin_into_raw)),
-        },
+        Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::into_raw)),
         Type::Ref(ty) => match &ty.inner {
             Type::Ident(ident) if ident.rust == RustString => match ty.mutable {
                 false => Some(quote!(::cxx::private::RustString::from_ref)),
diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index 3bb3ed3..baba32e 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -91,16 +91,6 @@ where
             ty: PhantomData,
         }
     }
-
-    #[doc(hidden)]
-    pub unsafe fn __pin_into_raw(ptr: Pin<UniquePtr<T>>) -> *mut T {
-        Self::into_raw(Pin::into_inner_unchecked(ptr))
-    }
-
-    #[doc(hidden)]
-    pub unsafe fn __pin_from_raw(raw: *mut T) -> Pin<Self> {
-        Pin::new_unchecked(Self::from_raw(raw))
-    }
 }
 
 unsafe impl<T> Send for UniquePtr<T> where T: Send + UniquePtrTarget {}
diff --git a/syntax/impls.rs b/syntax/impls.rs
index c11c386..a9c48c3 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -81,36 +81,29 @@ impl Eq for Ty1 {}
 impl PartialEq for Ty1 {
     fn eq(&self, other: &Ty1) -> bool {
         let Ty1 {
-            pinned,
             name,
             langle: _,
             inner,
             rangle: _,
-            pin_tokens: _,
         } = self;
         let Ty1 {
-            pinned: pinned2,
             name: name2,
             langle: _,
             inner: inner2,
             rangle: _,
-            pin_tokens: _,
         } = other;
-        pinned == pinned2 && name == name2 && inner == inner2
+        name == name2 && inner == inner2
     }
 }
 
 impl Hash for Ty1 {
     fn hash<H: Hasher>(&self, state: &mut H) {
         let Ty1 {
-            pinned,
             name,
             langle: _,
             inner,
             rangle: _,
-            pin_tokens: _,
         } = self;
-        pinned.hash(state);
         name.hash(state);
         inner.hash(state);
     }
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 131639f..2a3790c 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -168,12 +168,10 @@ pub enum Type {
 }
 
 pub struct Ty1 {
-    pub pinned: bool,
     pub name: Ident,
     pub langle: Token![<],
     pub inner: Type,
     pub rangle: Token![>],
-    pub pin_tokens: Option<(kw::Pin, Token![<], Token![>])>,
 }
 
 pub struct Ref {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 5e10116..ec89cbb 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -666,48 +666,40 @@ fn parse_type_path(ty: &TypePath, namespace: &Namespace) -> Result<Type> {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg, namespace)?;
                         return Ok(Type::UniquePtr(Box::new(Ty1 {
-                            pinned: false,
                             name: ident,
                             langle: generic.lt_token,
                             inner,
                             rangle: generic.gt_token,
-                            pin_tokens: None,
                         })));
                     }
                 } else if ident == "CxxVector" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg, namespace)?;
                         return Ok(Type::CxxVector(Box::new(Ty1 {
-                            pinned: false,
                             name: ident,
                             langle: generic.lt_token,
                             inner,
                             rangle: generic.gt_token,
-                            pin_tokens: None,
                         })));
                     }
                 } else if ident == "Box" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg, namespace)?;
                         return Ok(Type::RustBox(Box::new(Ty1 {
-                            pinned: false,
                             name: ident,
                             langle: generic.lt_token,
                             inner,
                             rangle: generic.gt_token,
-                            pin_tokens: None,
                         })));
                     }
                 } else if ident == "Vec" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg, namespace)?;
                         return Ok(Type::RustVec(Box::new(Ty1 {
-                            pinned: false,
                             name: ident,
                             langle: generic.lt_token,
                             inner,
                             rangle: generic.gt_token,
-                            pin_tokens: None,
                         })));
                     }
                 } else if ident == "Pin" && generic.args.len() == 1 {
@@ -719,11 +711,6 @@ fn parse_type_path(ty: &TypePath, namespace: &Namespace) -> Result<Type> {
                             inner.pin_tokens =
                                 Some((pin_token, generic.lt_token, generic.gt_token));
                             return Ok(Type::Ref(inner));
-                        } else if let Type::UniquePtr(mut inner) = inner {
-                            inner.pinned = true;
-                            inner.pin_tokens =
-                                Some((pin_token, generic.lt_token, generic.gt_token));
-                            return Ok(Type::UniquePtr(inner));
                         }
                     }
                 }
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index af8088d..40ab723 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -40,10 +40,6 @@ impl ToTokens for Ty1 {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         let span = self.name.span();
         let name = self.name.to_string();
-        if let Some((pin, langle, _rangle)) = self.pin_tokens {
-            tokens.extend(quote_spanned!(pin.span=> ::std::pin::Pin));
-            langle.to_tokens(tokens);
-        }
         if let "UniquePtr" | "CxxVector" = name.as_str() {
             tokens.extend(quote_spanned!(span=> ::cxx::));
         } else if name == "Vec" {
@@ -53,9 +49,6 @@ impl ToTokens for Ty1 {
         self.langle.to_tokens(tokens);
         self.inner.to_tokens(tokens);
         self.rangle.to_tokens(tokens);
-        if let Some((_pin, _langle, rangle)) = self.pin_tokens {
-            rangle.to_tokens(tokens);
-        }
     }
 }
 

